 lst off

* UNIX coff utility
* variables
*
* 1990-1992, tao Developer Project

 rel
 xc
 xc
 mx %00

 put coff.h ;coff defines
 put getopt.h ;getopt command-line library definitions

 use coff.mac ;macro file
 use datatype.mac ;data-type definitions
 use getopt.mac

* variables
*
coff ent
 str 'coff'
userID ent ;userID returned by MMStartUp
 dw 0
long_hex_str ent ;string hex representation of long value
short_hex_str ent ;string hex representation of short value
char_hex_str ent ;string hex representation of char value
long_dec_str ent ;string decimal representation of long value
short_dec_str ent ;string decimal representation of short value
char_dec_str ent ;string decimal representation of char value
 ds 11
blank_str ent ;blank string
 ds 80,' '
vert_separator ent ;separate displacement/bytes
 cStr ') | '
space_vert_bar ent ;spaced vertical bar
 cStr '               | '
space_12 ent ;space between left edge and operand
 cStr '            '

;assembly record names
DS_asm ent ;DS directive
 cStr 'ds     '
GEQU_asm ent ;GEQU directive
 cStr 'gequ   '
EQU_asm ent ;EQU directive
 cStr 'equ    '
hex_asm ent ;merlin hex directive
 cStr 'hex    '
db_asm ent ;merlin db directive
 cStr 'db     '
dw_asm ent ;merlin dw directive
 cStr 'dw     '
adr_asm ent ;merlin adr directive
 cStr 'adr    '
adrl_asm ent ;merlin adrl directive
 cStr 'adrl   '
dc_a_asm ent ;orca address directive
 cStr 'dc     a'
dc_h_asm ent ;orca hex directive
 asc !dc h'!,00
dc_i_asm ent ;orca integer directive
 cStr 'dc     i'
dc_d_asm ent ;orca double directive
 asc !dc d'!,00
dc_e_asm ent ;orca extended directive
 asc !dc e'!,00
dc_f_asm ent ;orca float directive
 asc !dc f'!,00


* boolean bariables
*
}version ent ;display version number
 Boolean
}tool ent ;interpret ToolBox, GS/OS, ProDOS, ROM calls
 Boolean
}assembly ent ;dump in asm format
 Boolean
}label ent ;print expressions with labels, not offsets
 Boolean
}infix ent ;display expressions in infix (default for +asm)
 Boolean
}postfix ent ;display expressions in postfix (default)
 Boolean
}hex ent ;nonzero means dump in hex format
 Boolean
}header ent ;nonzero means dump
 Boolean
}noheader ent ;nonzero does not display segment headers
 Boolean
}nooffset ent ;nonzero means don't print offset into file
 Boolean
}help ent ;nonzero means print switch descriptions
 Boolean
}shorta ent ;8-bit accumulator
 Boolean
}shorti ent ;8-bit index registers
 Boolean
}compress ent ;compress OMF listing
 Boolean
}exact ent ;match segment, loadsegment names exactly
 Boolean
}default_opt ent ;disable default options
 Boolean

* constant variables
*
~assembler ent ;output code for which assembler
 dw 0 ;00000001 - Merlin 16
;00000010 - Orca/M
~error_msg ent ;error messages
 dw :no_filename,:invalid_filename
 dw :premature_end,:omf_version
 dw :invalid_length,:more_data
:no_filename cStr 'object filename not specified'
:invalid_filename cStr 'error opening OMF file: '
:premature_end cStr 'premature end of file'
:omf_version cStr 'OMF v1.0 and v2.0 supported. received: v'
:invalid_length cStr 'segment length must be less than 64k. received: $'
:more_data cStr 'data left in file but not enough to make sense of'

;format of ~opcodes
;word - number of bytes opcode generates
;word - if 16-bit mode accumulator
;word - if 16-bit mode index register
;word - addressing mode
;string - opcode name
;cstring - operand format
~opcodes ent ;65816 opcodes
 dw :00,:01,:02,:03,:04,:05,:06,:07,:08,:09,:0a
 dw :0b,:0c,:0d,:0e,:0f,:10,:11,:12,:13,:14,:15
 dw :16,:17,:18,:19,:1a,:1b,:1c,:1d,:1e,:1f,:20
 dw :21,:22,:23,:24,:25,:26,:27,:28,:29,:2a,:2b
 dw :2c,:2d,:2e,:2f,:30,:31,:32,:33,:34,:35,:36
 dw :37,:38,:39,:3a,:3b,:3c,:3d,:3e,:3f,:40,:41
 dw :42,:43,:44,:45,:46,:47,:48,:49,:4a,:4b,:4c
 dw :4d,:4e,:4f,:50,:51,:52,:53,:54,:55,:56,:57
 dw :58,:59,:5a,:5b,:5c,:5d,:5e,:5f,:60,:61,:62
 dw :63,:64,:65,:66,:67,:68,:69,:6a,:6b,:6c,:6d
 dw :6e,:6f,:70,:71,:72,:73,:74,:75,:76,:77,:78
 dw :79,:7a,:7b,:7c,:7d,:7e,:7f,:80,:81,:82,:83
 dw :84,:85,:86,:87,:88,:89,:8a,:8b,:8c,:8d,:8e
 dw :8f,:90,:91,:92,:93,:94,:95,:96,:97,:98,:99
 dw :9a,:9b,:9c,:9d,:9e,:9f,:a0,:a1,:a2,:a3,:a4
 dw :a5,:a6,:a7,:a8,:a9,:aa,:ab,:ac,:ad,:ae,:af
 dw :b0,:b1,:b2,:b3,:b4,:b5,:b6,:b7,:b8,:b9,:ba
 dw :bb,:bc,:bd,:be,:bf,:c0,:c1,:c2,:c3,:c4,:c5
 dw :c6,:c7,:c8,:c9,:ca,:cb,:cc,:cd,:ce,:cf,:d0
 dw :d1,:d2,:d3,:d4,:d5,:d6,:d7,:d8,:d9,:da,:db
 dw :dc,:dd,:de,:df,:e0,:e1,:e2,:e3,:e4,:e5,:e6
 dw :e7,:e8,:e9,:ea,:eb,:ec,:ed,:ee,:ef,:f0,:f1
 dw :f2,:f3,:f4,:f5,:f6,:f7,:f8,:f9,:fa,:fb,:fc
 dw :fd,:fe,:ff
:00 stack_interrupt 'brk' ;$00
:01 dp_index_indirect_x 'ora' ;$01
:02 stack_interrupt 'cop' ;$02
:03 sr 'ora' ;$03
:04 dp 'tsb' ;$04
:05 dp 'ora' ;$05
:06 dp 'asl' ;$06
:07 dp_indirect_long 'ora' ;$07
:08 stack_push 'php' ;$08
:09 immediate_m 'ora' ;$09
:0a accumulator 'asl' ;$0a
:0b stack_push 'phd' ;$0b
:0c absolute 'tsb' ;$0c
:0d absolute 'ora' ;$0d
:0e absolute 'asl' ;$0e
:0f absolute_long 'asl' ;$0f
:10 pc_relative 'bpl' ;$10
:11 dp_indirect_index_y 'ora' ;$11
:12 dp_indirect 'ora' ;$12
:13 sr_indirect_index_y 'ora' ;$13
:14 dp 'trb' ;$14
:15 dp_index_x 'ora' ;$15
:16 dp_index_x 'asl' ;$16
:17 dp_indirect_long_index_y 'ora' ;$17
:18 implied 'clc' ;$18
:19 absolute_index_y 'ora' ;$19
:1a accumulator 'inc' ;$1a
:1b implied 'tcs' ;$1b
:1c absolute 'trb' ;$1c
:1d absolute_index_x 'ora' ;$1d
:1e absolute_index_x 'asl' ;$1e
:1f absolute_long_index_x 'ora' ;$1f
:20 absolute 'jsr' ;$20
:21 dp_index_indirect_x 'and' ;$21
:22 absolute_long 'jsl' ;$22
:23 sr 'and' ;$23
:24 dp 'bit' ;$24
:25 dp 'and' ;$25
:26 dp 'rol' ;$26
:27 dp_indirect_long 'and' ;$27
:28 stack_pull 'plp' ;$28
:29 immediate_m 'and' ;$29
:2a accumulator 'rol' ;$2a
:2b stack_pull 'pld' ;$2b
:2c absolute 'bit' ;$2c
:2d absolute 'and' ;$2d
:2e absolute 'rol' ;$2e
:2f absolute_long 'and' ;$2f
:30 pc_relative 'bmi' ;$30
:31 dp_indirect_index_y 'and' ;$31
:32 dp_indirect 'and' ;$32
:33 sr_indirect_index_y 'and' ;$33
:34 dp_index_x 'bit' ;$34
:35 dp_index_x 'and' ;$35
:36 dp_index_x 'rol' ;$36
:37 dp_indirect_long_index_y 'and' ;$37
:38 implied 'sec' ;$38
:39 absolute_index_y 'and' ;$39
:3a accumulator 'dec' ;$3a
:3b implied 'tsc' ;$3b
:3c absolute_index_x 'bit' ;$3c
:3d absolute_index_x 'and' ;$3d
:3e absolute_index_x 'rol' ;$3e
:3f absolute_long_index_x 'and' ;$3f
:40 stack_rti 'rti' ;$40
:41 dp_index_indirect_x 'eor' ;$41
:42 wdm_ 'wdm' ;$42
:43 sr 'eor' ;$43
:44 block_move 'mvp' ;$44
:45 dp 'eor' ;$45
:46 dp 'lsr' ;$46
:47 dp_indirect_long 'eor' ;$47
:48 stack_push 'pha' ;$48
:49 immediate_m 'eor' ;$49
:4a accumulator 'lsr' ;$4a
:4b stack_push 'phk' ;$4b
:4c absolute 'jmp' ;$4c
:4d absolute 'eor' ;$4d
:4e absolute 'lsr' ;$4e
:4f absolute_long 'eor' ;$4f
:50 pc_relative 'bvc' ;$50
:51 dp_indirect_index_y 'eor' ;$51
:52 dp_indirect 'eor' ;$52
:53 sr_indirect_index_y 'eor' ;$53
:54 block_move 'mvn' ;$54
:55 dp_index_x 'eor' ;$55
:56 dp_index_x 'lsr' ;$56
:57 dp_indirect_long_index_y 'eor' ;$57
:58 implied 'cli' ;$58
:59 absolute_index_y 'eor' ;$59
:5a stack_push 'phy' ;$5a
:5b implied 'tcd' ;$5b
:5c absolute_long 'jmp' ;$5c
:5d absolute_index_x 'eor' ;$5d
:5e absolute_index_x 'lsr' ;$5e
:5f absolute_long_index_x 'eor' ;$5f
:60 stack_rts 'rts' ;$60
:61 dp_index_indirect_x 'adc' ;$61
:62 stack_pc_relative 'per' ;$62
:63 sr 'adc' ;$63
:64 dp 'stz' ;$64
:65 dp 'adc' ;$65
:66 dp 'ror' ;$66
:67 dp_indirect_long 'adc' ;$67
:68 stack_pull 'pla' ;$68
:69 immediate_m 'adc' ;$69
:6a accumulator 'ror' ;$6a
:6b stack_rtl 'rtl' ;$6b
:6c absolute_indirect 'jmp' ;$6c
:6d absolute 'adc' ;$6d
:6e absolute 'ror' ;$6e
:6f absolute_long 'adc' ;$6f
:70 pc_relative 'bvs' ;$70
:71 dp_indirect_index_y 'adc' ;$71
:72 dp_indirect 'adc' ;$72
:73 sr_indirect_index_y 'adc' ;$73
:74 dp_index_x 'stz' ;$74
:75 dp_index_x 'adc' ;$75
:76 dp_index_x 'ror' ;$76
:77 dp_indirect_long_index_y 'adc' ;$77
:78 implied 'sei' ;$78
:79 absolute_index_y 'adc' ;$79
:7a stack_pull 'ply' ;$7a
:7b implied 'tdc' ;$7b
:7c absolute_index_indirect 'jmp' ;$7c
:7d absolute_index_x 'adc' ;$7d
:7e absolute_index_x 'ror' ;$7e
:7f absolute_long_index_x 'adc' ;$7f
:80 pc_relative 'bra' ;$80
:81 dp_index_indirect_x 'sta' ;$81
:82 pc_relative_long 'brl' ;$82
:83 sr 'sta' ;$83
:84 dp 'sty' ;$84
:85 dp 'sta' ;$85
:86 dp 'stx' ;$86
:87 dp_indirect_long 'sta' ;$87
:88 implied 'dey' ;$88
:89 immediate_m 'bit' ;$89
:8a implied 'txa' ;$8a
:8b stack_push 'phb' ;$8b
:8c absolute 'sty' ;$8c
:8d absolute 'sta' ;$8d
:8e absolute 'stx' ;$8e
:8f absolute_long 'sta' ;$8f
:90 pc_relative 'bcc' ;$90
:91 dp_indirect_index_y 'sta' ;$91
:92 dp_indirect 'sta' ;$92
:93 sr_indirect_index_y 'sta' ;$93
:94 dp_index_x 'sty' ;$94
:95 dp_index_x 'sta' ;$95
:96 dp_index_y 'stx' ;$96
:97 dp_indirect_long_index_y 'sta' ;$97
:98 implied 'tya' ;$98
:99 absolute_index_y 'sta' ;$99
:9a implied 'txs' ;$9a
:9b implied 'txy' ;$9b
:9c absolute 'stz' ;$9c
:9d absolute_index_x 'sta' ;$9d
:9e absolute_index_x 'stz' ;$9e
:9f absolute_long_index_x 'sta' ;$9f
:a0 immediate_i 'ldy' ;$a0
:a1 dp_index_indirect_x 'lda' ;$a1
:a2 immediate_i 'ldx' ;$a2
:a3 sr 'lda' ;$a3
:a4 dp 'ldy' ;$a4
:a5 dp 'lda' ;$a5
:a6 dp 'ldx' ;$a6
:a7 dp_indirect_long 'lda' ;$a7
:a8 implied 'tay' ;$a8
:a9 immediate_m 'lda' ;$a9
:aa implied 'tax' ;$aa
:ab stack_pull 'plb' ;$ab
:ac absolute 'ldy' ;$ac
:ad absolute 'lda' ;$ad
:ae absolute 'ldx' ;$ae
:af absolute_long 'lda' ;$af
:b0 pc_relative 'bcs' ;$b0
:b1 dp_indirect_index_y 'lda' ;$b1
:b2 dp_indirect 'lda' ;$b2
:b3 sr_indirect_index_y 'lda' ;$b3
:b4 dp_index_x 'ldy' ;$b4
:b5 dp_index_x 'lda' ;$b5
:b6 dp_index_y 'ldx' ;$b6
:b7 dp_indirect_long_index_y 'lda' ;$b7
:b8 implied 'clv' ;$b8
:b9 absolute_index_y 'lda' ;$b9
:ba implied 'tsx' ;$ba
:bb implied 'tyx' ;$bb
:bc absolute_index_x 'ldy' ;$bc
:bd absolute_index_x 'lda' ;$bd
:be absolute_index_y 'ldx' ;$be
:bf absolute_long_index_x 'lda' ;$bf
:c0 immediate_i 'cpy' ;$c0
:c1 dp_index_indirect_x 'cmp' ;$c1
:c2 immediate_rep 'rep' ;$c2
:c3 sr 'cmp' ;$c3
:c4 dp 'cpy' ;$c4
:c5 dp 'cmp' ;$c5
:c6 dp 'dec' ;$c6
:c7 dp_indirect_long 'cmp' ;$c7
:c8 implied 'iny' ;$c8
:c9 immediate_m 'cmp' ;$c9
:ca implied 'dex' ;$ca
:cb implied 'wait' ;$cb
:cc absolute 'cpy' ;$cc
:cd absolute 'cmp' ;$cd
:ce absolute 'dec' ;$ce
:cf absolute_long 'cmp' ;$cf
:d0 pc_relative 'bne' ;$d0
:d1 dp_indirect_index_y 'cmp' ;$d1
:d2 dp_indirect 'cmp' ;$d2
:d3 sr_indirect_index_y 'cmp' ;$d3
:d4 stack_dp_indirect 'pei' ;$d4
:d5 dp_index_x 'cmp' ;$d5
:d6 dp_index_x 'dec' ;$d6
:d7 dp_indirect_long_index_y 'cmp' ;$d7
:d8 implied 'cld' ;$d8
:d9 absolute_index_y 'cmp' ;$d9
:da stack_push 'phx' ;$da
:db implied 'stp' ;$db
:dc absolute_indirect_long 'jmp' ;$dc
:dd absolute_index_x 'cmp' ;$dd
:de absolute_index_x 'dec' ;$de
:df absolute_long_index_x 'cmp' ;$df
:e0 immediate_i 'cpx' ;$e0
:e1 dp_index_indirect_x 'sbc' ;$e1
:e2 immediate_sep 'sep' ;$e2
:e3 sr 'sbc' ;$e3
:e4 dp 'cpx' ;$e4
:e5 dp 'sbc' ;$e5
:e6 dp 'inc' ;$e6
:e7 dp_indirect_long 'sbc' ;$e7
:e8 implied 'inx' ;$e8
:e9 immediate_m 'sbc' ;$e9
:ea implied 'nop' ;$ea
:eb implied 'xba' ;$eb
:ec absolute 'cpx' ;$ec
:ed absolute 'sbc' ;$ed
:ee absolute 'inc' ;$ee
:ef absolute_long 'sbc' ;$ef
:f0 pc_relative 'beq' ;$f0
:f1 dp_indirect_index_y 'sbc' ;$f1
:f2 dp_indirect 'sbc' ;$f2
:f3 sr_indirect_index_y 'sbc' ;$f3
:f4 stack_absolute 'pea' ;$f4
:f5 dp_index_x 'sbc' ;$f5
:f6 dp_index_x 'inc' ;$f6
:f7 dp_indirect_long_index_y 'sbc' ;$f7
:f8 implied 'sed' ;$f8
:f9 absolute_index_y 'sbc' ;$f9
:fa stack_pull 'plx' ;$fa
:fb implied 'xce' ;$fb
:fc absolute_index_indirect 'jsr';$fc
:fd absolute_index_x 'sbc' ;$fb
:fe absolute_index_x 'inc' ;$fe
:ff absolute_long_index_x 'sbc' ;$ff

~operator ent ;operator precedence
 operator 0;0 ;no operator of value $00
 operator 3;LEFT_RIGHT ;addition
 operator 3;LEFT ;subtraction
 operator 2;LEFT_RIGHT ;multiplication
 operator 2;LEFT ;division
 operator 2;LEFT ;modulus
 operator 1;LEFT_RIGHT ;negation
 operator 4;LEFT ;bit shift
 operator 10;LEFT ;and
 operator 11;LEFT ;or
 operator 12;LEFT ;eor
 operator 1;LEFT_RIGHT ;not
 operator 5;LEFT ;less than or equal
 operator 5;LEFT ;greater than or equal
 operator 6;LEFT ;not equal
 operator 5;LEFT ;less than
 operator 5;LEFT ;greater than
 operator 6;LEFT ;equal
 operator 7;LEFT ;logical and
 operator 9;LEFT ;inclusive or
 operator 8;LEFT ;exculsive or
 operator 1;LEFT_RIGHT ;complement

~long_options ent ;command-line options accepted by coff
 dw :version,:nodefault,:asm,:tool
 dw :hex,:label,:infix,:postfix
 dw :merlin,:orca,:shorta,:shorti
 dw :header,:noheader,:nooffset
 dw :help,:thanks,:compress,:exact
 dw :NULL
:version option 'version';0;NULL;'v'
:nodefault option 'nodefault';0;NULL;'D'
:asm option 'asm';0;NULL;'d'
:tool option 'tool';0;NULL;'T'
:hex option 'hex';0;NULL;'x'
:label option 'label';0;NULL;'l'
:infix option 'infix';0;NULL;'t'
:postfix option 'postfix';0;NULL;'p'
:merlin option 'merlin';0;NULL;'m'
:orca option 'orca';0;NULL;'o'
:shorta option 'shorta';0;NULL;'a'
:shorti option 'shorti';0;NULL;'i'
:header option 'header';0;NULL;'s'
:noheader option 'noheader';0;NULL;'n'
:nooffset option 'nooffset';0;NULL;'f'
:help option 'help';0;NULL;'h'
:thanks option 'thanks';0;NULL;1
:compress option 'compress';0;NULL;'c'
:exact option 'exact';0;NULL;'e'
:NULL option NULL;0;NULL;0

* data structure variables
*
@omf ent ;OMF header structure
:offset UnsignedLong ;offset from beginning of file for this segment
:bytecnt UnsignedLong ;number of bytes in file that segment requires
:resspc UnsignedLong ;number of bytes of zeros to add to end of segment
:length UnsignedLong ;memory size of segment
:kind UnsignedShort ;type and attributes of segment
:lablen UnsignedShort ;length of each name or label record in segment
:numlen UnsignedShort ;length of each number field in segment body
:version UnsignedShort ;version number of OMF segment is compatible with
:revision UnsignedShort ;revision number of OMF v2.0 segment is compatible with
:banksize UnsignedLong ;maximum memory-bank size for segment
:org UnsignedLong ;absolute address at which to load segment
:align UnsignedLong ;boundary on which to align segment
:numsex UnsignedShort ;order of bytes in a number field
:lcbank UnsignedShort ;load segment into language card
:segnum UnsignedShort ;segment number
:entry UnsignedLong ;offset into segment that corresponds to entry point
:dispname UnsignedShort ;displacement of the loadname field within segment header
:dispdata UnsignedShort ;displacement from start of segment header to start of segment body
:temporg UnsignedLong ;temporary origin of object segment for OMF v2.0
:loadname Char LOADNAME_LEN ;name of load segment
:segname CharPtr ;name of segment
:displacement UnsignedLong
:counter UnsignedLong
:library UnsignedShort ;if file is a library
:refNum Word ;reference number associated with file

@parse_data ent ;global/local data parsing structure
:on Boolean ;test if parsing on
:data_type Boolean ;type of data to parse
:count UnsignedShort ;number of records to parse
:edge UnsignedShort ;right margin for output of data

@label ent ;label references
:label_name Handle ;name of label
:expr_name Handle ;expression label evaluates to
:type UnsignedShort ;GLOBAL or LOCAL label
:next Handle ;next label reference
:prev Handle ;previous label reference
:last Handle ;last label reference

@expr_list ent ;expression list
:lo Handle ;handle to array of expressions
:hi Handle
:size UnsignedShort ;number of elements in list

@btree ent ;binary-tree structure
:ptr dw :0,:1,:2,:3,:4,:5,:6,:7,:8,:9 ;elements in binary tree array
 dw :10,:11,:12,:13,:14,:15,:16,:17,:18,:19
 dw :20,:21,:22,:23,:24,:25,:26,:27,:28,:29
 dw :30,:31,:32,:33,:34,:35,:36,:37,:38,:39
 dw :40,:41,:42,:43,:44,:45,:46,:47,:48,:49
:0 ds 10
:1 ds 10
:2 ds 10
:3 ds 10
:4 ds 10
:5 ds 10
:6 ds 10
:7 ds 10
:8 ds 10
:9 ds 10
:10 ds 10
:11 ds 10
:12 ds 10
:13 ds 10
:14 ds 10
:15 ds 10
:16 ds 10
:17 ds 10
:18 ds 10
:19 ds 10
:20 ds 10
:21 ds 10
:22 ds 10
:23 ds 10
:24 ds 10
:25 ds 10
:26 ds 10
:27 ds 10
:28 ds 10
:29 ds 10
:30 ds 10
:31 ds 10
:32 ds 10
:33 ds 10
:34 ds 10
:35 ds 10
:36 ds 10
:37 ds 10
:38 ds 10
:39 ds 10
:40 ds 10
:41 ds 10
:42 ds 10
:43 ds 10
:44 ds 10
:45 ds 10
:46 ds 10
:47 ds 10
:48 ds 10
:49 ds 10

@stack ent ;stack structure
:lo Handle ;array of handles containing stack
:hi Handle ;elements
:size UnsignedShort ;number of elements in stack

* gs/os data structures
*
@Close ent
:pCount dw 1
:refNum ds 2

@Open ent
:pCount dw 15
:refNum ds 2
:pathname ds 4
:requestAccess dw 1
:resourceNumber ds 2
:access ds 2
:fileType ds 2
:auxType ds 4
:storageType ds 4
:createDateTime ds 8
:modDateTime ds 8
:optionList ds 4
:eof ds 4
:blocksUsed ds 4
:resourceEOF ds 4
:resourceBlocks ds 4

@GetMark ent
:pCount dw 2
:refNum ds 2
:position ds 4

@SetMark ent
:pCount dw 3
:refNum ds 2
:base ds 2
:displacement ds 4

@Quit ent
:pCount dw 2
:pathname ds 4
:flags ds 2

@Read ent
:pCount dw 5
:refNum ds 2
:dataBuffer ds 4
:requestCount ds 4
:transferCount ds 4
:cachePriority ds 2


**************************************************
 sav link/data.l
