         lst   off

* UNIX coff utility
* output routines
*
* 1990-1992, tao Developer Project
* 2019, Brutal Deluxe Software

         rel
         xc
         xc
         mx    %00

         put   coff.h     ;global defines
         put   x.data     ;data externals

GSOS     =     $e100a8    ; entry point

*----------------------------
* IN:
*  No parms
*
* OUT:
*  No parms

GSOSclose ent
         jsl   GSOS
         dw    $2014
         adrl  @Close
         rts

*----------------------------
* IN:
*  No parms
*
* OUT:
*  Y is low word
*  X is high word
*

GSOSget_mark ent
         jsl   GSOS
         dw    $2017
         adrl  @GetMark

         ldy   @GetMark+GetMark`position
         ldx   @GetMark+GetMark`position+2
         rts

*----------------------------
* IN:
*  X is low word
*  Y is high word
* It points to a C string filename
*
* OUT:
*  X is file length
*  Y is file length+2

GSOSopen ent

         stx   loopOPEN+1
         sep   #$30
         sty   loopOPEN+3
         ldx   #0
loopOPEN ldal  $bdbdbd,x
         beq   loopEND
         sta   myFILE,x
         inx
         cpx   #44
         bcs   openERR    ; len is too long
         bcc   loopOPEN

loopEND  rep   #$30
         stx   myPATH

         ldx   #myPATH
         stx   @Open+Open`pathname
         ldy   #^myPATH
         sty   @Open+Open`pathname+2

         jsl   GSOS
         dw    $2010
         adrl  @Open

         php
         pha

         lda   @Open+Open`refNum
         sta   @Close+Close`refNum
         sta   @GetMark+GetMark`refNum
         sta   @SetMark+SetMark`refNum
         sta   @Read+Read`refNum

         ldx   @Open+Open`eof
         ldy   @Open+Open`eof+2

         pla
         plp
         rts
openERR  rep   #$30
         rts

*--- myPATH is len(myFILENAME)+2

myPATH   ds    2          ; for STRL
myFILE   ds    48         ; name of file

*----------------------------
* IN:
*  A is number of bytes
*  X is low pointer
*  Y is high pointer
*
* OUT:
*  X is transfer count
*

GSOSread ent
         sta   @Read+Read`requestCount
         stz   @Read+Read`requestCount+2
         stx   @Read+Read`dataBuffer
         sty   @Read+Read`dataBuffer+2

         jsl   GSOS
         dw    $2012
         adrl  @Read

         ldx   @Read+Read`transferCount
         rts

*----------------------------
* IN:
*  Y is low word
*  X is high word
*
* OUT:
*  No parms
*

GSOSset_mark ent
         stz   @SetMark+SetMark`base

         sty   @SetMark+SetMark`displacement
         stx   @SetMark+SetMark`displacement+2

         jsl   GSOS
         dw    $2016
         adrl  @SetMark
         rts

*----------------------------
* IN:
*  X is low displacement
*  Y is high displacement
*
* OUT:
*  No parms
*

GSOSset_mark_plus ent
         lda   #2         ; mark += displacement
         sta   @SetMark+SetMark`base

         stx   @SetMark+SetMark`displacement
         sty   @SetMark+SetMark`displacement+2

         jsl   GSOS
         dw    $2016
         adrl  @SetMark
         rts

**************************************************
         sav   link/gsos.l
